/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.200 Revision 1.230
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.200 2005/09/23 20:44:26 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.230 2006/03/17 23:23:30 vapier Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
60# to point to the latest version of the library present. 60# to point to the latest version of the library present.
61# 61#
62# <azarah@gentoo.org> (26 Oct 2002) 62# <azarah@gentoo.org> (26 Oct 2002)
63# 63#
64gen_usr_ldscript() { 64gen_usr_ldscript() {
65 local libdir="$(get_libdir)" 65 local lib libdir=$(get_libdir)
66 # Just make sure it exists 66 # Just make sure it exists
67 dodir /usr/${libdir} 67 dodir /usr/${libdir}
68 68
69 for lib in "${@}" ; do 69 for lib in "${@}" ; do
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
76 76
77 See bug http://bugs.gentoo.org/4411 for more info. 77 See bug http://bugs.gentoo.org/4411 for more info.
78 */ 78 */
79 GROUP ( /${libdir}/${lib} ) 79 GROUP ( /${libdir}/${lib} )
80 END_LDSCRIPT 80 END_LDSCRIPT
81 fperms a+x "/usr/${libdir}/${lib}" 81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}"
82 done 82 done
83} 83}
84 84
85# Simple function to draw a line consisting of '=' the same length as $*
86# - only to be used by epatch()
87#
88# <azarah@gentoo.org> (11 Nov 2002)
89#
90draw_line() {
91 local i=0
92 local str_length=""
93
94 # Handle calls that do not have args, or wc not being installed ...
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
96 then
97 echo "==============================================================="
98 return 0
99 fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done
110
111 echo
112
113 return 0
114}
115 85
116# Default directory where patches are located 86# Default directory where patches are located
117EPATCH_SOURCE="${WORKDIR}/patch" 87EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 88# Default extension for patches
119EPATCH_SUFFIX="patch.bz2" 89EPATCH_SUFFIX="patch.bz2"
120# Default options for patch 90# Default options for patch
121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 91# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571
122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 92# Set --no-backup-if-mismatch so we don't leave '.orig' files behind.
93# Set -E to automatically remove empty files.
123EPATCH_OPTS="-g0 --no-backup-if-mismatch" 94EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
124# List of patches not to apply. Not this is only file names, 95# List of patches not to apply. Not this is only file names,
125# and not the full path .. 96# and not the full path ..
126EPATCH_EXCLUDE="" 97EPATCH_EXCLUDE=""
127# Change the printed message for a single patch. 98# Change the printed message for a single patch.
128EPATCH_SINGLE_MSG="" 99EPATCH_SINGLE_MSG=""
166# hand its a directory, it will set EPATCH_SOURCE to this. 137# hand its a directory, it will set EPATCH_SOURCE to this.
167# 138#
168# <azarah@gentoo.org> (10 Nov 2002) 139# <azarah@gentoo.org> (10 Nov 2002)
169# 140#
170epatch() { 141epatch() {
142 _epatch_draw_line() {
143 [[ -z $1 ]] && set "$(printf "%65s" '')"
144 echo "${1//?/=}"
145 }
146 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
171 local PIPE_CMD="" 147 local PIPE_CMD=""
172 local STDERR_TARGET="${T}/$$.out" 148 local STDERR_TARGET="${T}/$$.out"
173 local PATCH_TARGET="${T}/$$.patch" 149 local PATCH_TARGET="${T}/$$.patch"
174 local PATCH_SUFFIX="" 150 local PATCH_SUFFIX=""
175 local SINGLE_PATCH="no" 151 local SINGLE_PATCH="no"
284 260
285 # Allow for prefix to differ ... im lazy, so shoot me :/ 261 # Allow for prefix to differ ... im lazy, so shoot me :/
286 while [ "${count}" -lt 5 ] 262 while [ "${count}" -lt 5 ]
287 do 263 do
288 # Generate some useful debug info ... 264 # Generate some useful debug info ...
289 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 265 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 266 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
291 267
292 if [ "${PATCH_SUFFIX}" != "patch" ] 268 if [ "${PATCH_SUFFIX}" != "patch" ]
293 then 269 then
294 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 270 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
299 275
300 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 276 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 277 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 278
303 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 279 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
304 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 280 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 281
306 if [ "${PATCH_SUFFIX}" != "patch" ] 282 if [ "${PATCH_SUFFIX}" != "patch" ]
307 then 283 then
308 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 284 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
309 then 285 then
313 count=5 289 count=5
314 break 290 break
315 fi 291 fi
316 fi 292 fi
317 293
318 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 294 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
319 then 295 then
320 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 296 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 297 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 298 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 299 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 300 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
325 301
326 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 302 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
303 _epatch_assert
327 304
328 if [ "$?" -ne 0 ] 305 if [ "$?" -ne 0 ]
329 then 306 then
330 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 307 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo 308 echo
394 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 371 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
395 done 372 done
396 ${exe} "${tmp}" || ${exe} -p "${tmp}" 373 ${exe} "${tmp}" || ${exe} -p "${tmp}"
397 echo "${tmp}" 374 echo "${tmp}"
398 else 375 else
399 [[ ${exe} == "touch" ]] \ 376 if [[ ${exe} == "touch" ]] ; then
400 && exe="-p" \ 377 [[ ${USERLAND} == "GNU" ]] \
401 || exe="-d" 378 && mktemp -p "${topdir}" \
402 mktemp ${exe} "${topdir}" 379 || TMPDIR="${topdir}" mktemp -t tmp
380 else
381 [[ ${USERLAND} == "GNU" ]] \
382 && mktemp -d "${topdir}" \
383 || TMPDIR="${topdir}" mktemp -dt tmp
384 fi
403 fi 385 fi
404} 386}
405 387
406# Small wrapper for getent (Linux), nidump (Mac OS X), 388# Small wrapper for getent (Linux), nidump (Mac OS X),
407# and pw (FreeBSD) used in enewuser()/enewgroup() 389# and pw (FreeBSD) used in enewuser()/enewgroup()
408# Joe Jezak <josejx@gmail.com> and usata@gentoo.org 390# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
409# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org> 391# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
410# 392#
411# egetent(database, key) 393# egetent(database, key)
412egetent() { 394egetent() {
413 if [[ "${USERLAND}" == "Darwin" ]] ; then 395 case ${CHOST} in
396 *-darwin*)
414 case "$2" in 397 case "$2" in
415 *[!0-9]*) # Non numeric 398 *[!0-9]*) # Non numeric
416 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 399 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
417 ;; 400 ;;
418 *) # Numeric 401 *) # Numeric
419 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 402 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
420 ;; 403 ;;
421 esac 404 esac
422 elif [[ "${USERLAND}" == "BSD" ]] ; then 405 ;;
423 local action 406 *-freebsd*|*-dragonfly*)
424 if [ "$1" == "passwd" ] 407 local opts action="user"
425 then 408 [[ $1 == "passwd" ]] || action="group"
426 action="user" 409
427 else 410 # lookup by uid/gid
428 action="group" 411 if [[ $2 == [[:digit:]]* ]] ; then
412 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
429 fi 413 fi
414
430 pw show "${action}" "$2" -q 415 pw show ${action} ${opts} "$2" -q
431 else 416 ;;
417 *-netbsd*|*-openbsd*)
418 grep "$2:\*:" /etc/$1
419 ;;
420 *)
432 which nscd >& /dev/null && nscd -i "$1" 421 type -p nscd >& /dev/null && nscd -i "$1"
433 getent "$1" "$2" 422 getent "$1" "$2"
434 fi 423 ;;
424 esac
435} 425}
436 426
437# Simplify/standardize adding users to the system 427# Simplify/standardize adding users to the system
438# vapier@gentoo.org 428# vapier@gentoo.org
439# 429#
487 einfo " - Userid: ${euid}" 477 einfo " - Userid: ${euid}"
488 478
489 # handle shell 479 # handle shell
490 local eshell=$1; shift 480 local eshell=$1; shift
491 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then 481 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
492 if [[ ! -e ${eshell} ]] ; then 482 if [[ ! -e ${ROOT}${eshell} ]] ; then
493 eerror "A shell was specified but it does not exist !" 483 eerror "A shell was specified but it does not exist !"
494 die "${eshell} does not exist" 484 die "${eshell} does not exist in ${ROOT}"
495 fi 485 fi
486 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
487 eerror "Do not specify ${eshell} yourself, use -1"
488 die "Pass '-1' as the shell parameter"
489 fi
496 else 490 else
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null; do 491 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break; 492 [[ -x ${ROOT}${shell} ]] && break
499 done 493 done
500 494
501 if [[ ${shell} == "/dev/null" ]]; then 495 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use" 496 eerror "Unable to identify the shell to use"
503 die "Unable to identify the shell to use" 497 die "Unable to identify the shell to use"
504 fi 498 fi
505 499
506 eshell=${shell} 500 eshell=${shell}
548 einfo " - Groups: ${egroups}" 542 einfo " - Groups: ${egroups}"
549 543
550 # handle extra and add the user 544 # handle extra and add the user
551 local oldsandbox=${SANDBOX_ON} 545 local oldsandbox=${SANDBOX_ON}
552 export SANDBOX_ON="0" 546 export SANDBOX_ON="0"
553 case ${USERLAND} in 547 case ${CHOST} in
554 Darwin) 548 *-darwin*)
555 ### Make the user 549 ### Make the user
556 if [[ -z $@ ]] ; then 550 if [[ -z $@ ]] ; then
557 dscl . create /users/${euser} uid ${euid} 551 dscl . create /users/${euser} uid ${euid}
558 dscl . create /users/${euser} shell ${eshell} 552 dscl . create /users/${euser} shell ${eshell}
559 dscl . create /users/${euser} home ${ehome} 553 dscl . create /users/${euser} home ${ehome}
570 einfo "Please report the ebuild along with the info below" 564 einfo "Please report the ebuild along with the info below"
571 einfo "eextra: $@" 565 einfo "eextra: $@"
572 die "Required function missing" 566 die "Required function missing"
573 fi 567 fi
574 ;; 568 ;;
575 BSD) 569 *-freebsd*|*-dragonfly*)
576 if [[ -z $@ ]] ; then 570 if [[ -z $@ ]] ; then
577 pw useradd ${euser} ${opts} \ 571 pw useradd ${euser} ${opts} \
578 -c "added by portage for ${PN}" \ 572 -c "added by portage for ${PN}" \
579 die "enewuser failed" 573 die "enewuser failed"
580 else 574 else
581 einfo " - Extra: $@" 575 einfo " - Extra: $@"
582 pw useradd ${euser} ${opts} \ 576 pw useradd ${euser} ${opts} \
583 "$@" || die "enewuser failed" 577 "$@" || die "enewuser failed"
584 fi 578 fi
585 ;; 579 ;;
580
581 *-netbsd*)
582 if [[ -z $@ ]] ; then
583 useradd ${opts} ${euser} || die "enewuser failed"
584 else
585 einfo " - Extra: $@"
586 useradd ${opts} ${euser} "$@" || die "enewuser failed"
587 fi
588 ;;
589
590 *-openbsd*)
591 if [[ -z $@ ]] ; then
592 useradd -u ${euid} -s ${eshell} \
593 -d ${ehome} -c "Added by portage for ${PN}" \
594 -g ${egroups} ${euser} || die "enewuser failed"
595 else
596 einfo " - Extra: $@"
597 useradd -u ${euid} -s ${eshell} \
598 -d ${ehome} -c "Added by portage for ${PN}" \
599 -g ${egroups} ${euser} "$@" || die "enewuser failed"
600 fi
601 ;;
602
586 *) 603 *)
587 if [[ -z $@ ]] ; then 604 if [[ -z $@ ]] ; then
588 useradd ${opts} ${euser} \ 605 useradd ${opts} ${euser} \
589 -c "added by portage for ${PN}" \ 606 -c "added by portage for ${PN}" \
590 || die "enewuser failed" 607 || die "enewuser failed"
640 then 657 then
641 if [ "${egid}" -gt 0 ] 658 if [ "${egid}" -gt 0 ]
642 then 659 then
643 if [ -z "`egetent group ${egid}`" ] 660 if [ -z "`egetent group ${egid}`" ]
644 then 661 then
645 if [[ "${USERLAND}" == "Darwin" ]]; then 662 if [[ "${CHOST}" == *-darwin* ]]; then
646 opts="${opts} ${egid}" 663 opts="${opts} ${egid}"
647 else 664 else
648 opts="${opts} -g ${egid}" 665 opts="${opts} -g ${egid}"
649 fi 666 fi
650 else 667 else
664 opts="${opts} ${eextra}" 681 opts="${opts} ${eextra}"
665 682
666 # add the group 683 # add the group
667 local oldsandbox="${SANDBOX_ON}" 684 local oldsandbox="${SANDBOX_ON}"
668 export SANDBOX_ON="0" 685 export SANDBOX_ON="0"
669 if [[ "${USERLAND}" == "Darwin" ]]; then 686 case ${CHOST} in
687 *-darwin*)
670 if [ ! -z "${eextra}" ]; 688 if [ ! -z "${eextra}" ];
671 then 689 then
672 einfo "Extra options are not supported on Darwin/OS X yet" 690 einfo "Extra options are not supported on Darwin/OS X yet"
673 einfo "Please report the ebuild along with the info below" 691 einfo "Please report the ebuild along with the info below"
674 einfo "eextra: ${eextra}" 692 einfo "eextra: ${eextra}"
675 die "Required function missing" 693 die "Required function missing"
676 fi 694 fi
677 695
678 # If we need the next available 696 # If we need the next available
679 case ${egid} in 697 case ${egid} in
680 *[!0-9]*) # Non numeric 698 *[!0-9]*) # Non numeric
681 for egid in $(seq 101 999); do 699 for egid in $(seq 101 999); do
682 [ -z "`egetent group ${egid}`" ] && break 700 [ -z "`egetent group ${egid}`" ] && break
683 done 701 done
684 esac 702 esac
685 dscl . create /groups/${egroup} gid ${egid} 703 dscl . create /groups/${egroup} gid ${egid}
686 dscl . create /groups/${egroup} passwd '*' 704 dscl . create /groups/${egroup} passwd '*'
687 elif [[ "${USERLAND}" == "BSD" ]] ; then 705 ;;
706
707 *-freebsd*|*-dragonfly*)
688 case ${egid} in 708 case ${egid} in
689 *[!0-9]*) # Non numeric 709 *[!0-9]*) # Non numeric
690 for egid in $(seq 101 999); do 710 for egid in $(seq 101 999); do
691 [ -z "`egetent group ${egid}`" ] && break 711 [ -z "`egetent group ${egid}`" ] && break
692 done 712 done
693 esac 713 esac
694 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 714 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
695 else 715 ;;
716
717 *-netbsd*)
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for egid in $(seq 101 999); do
721 [ -z "`egetent group ${egid}`" ] && break
722 done
723 esac
724 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
725 ;;
726
727 *)
696 groupadd ${opts} ${egroup} || die "enewgroup failed" 728 groupadd ${opts} ${egroup} || die "enewgroup failed"
697 fi 729 ;;
730 esac
698 export SANDBOX_ON="${oldsandbox}" 731 export SANDBOX_ON="${oldsandbox}"
699} 732}
700 733
701# Simple script to replace 'dos2unix' binaries 734# Simple script to replace 'dos2unix' binaries
702# vapier@gentoo.org 735# vapier@gentoo.org
813 type="Network;${type}" 846 type="Network;${type}"
814 ;; 847 ;;
815 848
816 sci) 849 sci)
817 case ${catmin} in 850 case ${catmin} in
818 astro*) type=Astronomoy;; 851 astro*) type=Astronomy;;
819 bio*) type=Biology;; 852 bio*) type=Biology;;
820 calc*) type=Calculator;; 853 calc*) type=Calculator;;
821 chem*) type=Chemistry;; 854 chem*) type=Chemistry;;
822 geo*) type=Geology;; 855 geo*) type=Geology;;
823 math*) type=Math;; 856 math*) type=Math;;
855Exec=${exec} 888Exec=${exec}
856Path=${path} 889Path=${path}
857Icon=${icon} 890Icon=${icon}
858Categories=Application;${type};" > "${desktop}" 891Categories=Application;${type};" > "${desktop}"
859 892
893 (
894 # wrap the env here so that the 'insinto' call
895 # doesn't corrupt the env of the caller
860 insinto /usr/share/applications 896 insinto /usr/share/applications
861 doins "${desktop}" 897 doins "${desktop}"
862 898 )
863 return 0
864} 899}
865 900
866# Make a GDM/KDM Session file 901# Make a GDM/KDM Session file
867# 902#
868# make_desktop_entry(<title>, <command>) 903# make_desktop_entry(<title>, <command>)
973 local sizeoff_t=$2 1008 local sizeoff_t=$2
974 1009
975 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1010 [[ -z ${src} ]] && die "Could not locate source for '$1'"
976 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1011 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
977 1012
978 local shrtsrc="`basename ${src}`" 1013 local shrtsrc=$(basename "${src}")
979 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1014 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
980 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1015 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
981 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1016 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
982 1017
983 # grab metadata for debug reasons 1018 # grab metadata for debug reasons
1047# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1082# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1048# - If the file is not specified then unpack will utilize ${A}. 1083# - If the file is not specified then unpack will utilize ${A}.
1049# - If the offset is not specified then we will attempt to extract 1084# - If the offset is not specified then we will attempt to extract
1050# the proper offset from the script itself. 1085# the proper offset from the script itself.
1051unpack_makeself() { 1086unpack_makeself() {
1087 local src_input=${1:-${A}}
1052 local src=$(find_unpackable_file "$1") 1088 local src=$(find_unpackable_file "${src_input}")
1053 local skip=$2 1089 local skip=$2
1054 local exe=$3 1090 local exe=$3
1055 1091
1056 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1092 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1057 1093
1058 local shrtsrc=$(basename "${src}") 1094 local shrtsrc=$(basename "${src}")
1059 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1095 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1060 if [ -z "${skip}" ] 1096 if [[ -z ${skip} ]] ; then
1061 then
1062 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1097 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1063 local skip=0 1098 local skip=0
1064 exe=tail 1099 exe=tail
1065 case ${ver} in 1100 case ${ver} in
1066 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1101 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1067 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1102 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1079 ;; 1114 ;;
1080 2.1.3) 1115 2.1.3)
1081 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1116 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1082 let skip="skip + 1" 1117 let skip="skip + 1"
1083 ;; 1118 ;;
1084 2.1.4) 1119 2.1.4|2.1.5)
1085 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1120 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1086 skip=$(head -n ${skip} "${src}" | wc -c) 1121 skip=$(head -n ${skip} "${src}" | wc -c)
1087 exe="dd" 1122 exe="dd"
1088 ;; 1123 ;;
1089 *) 1124 *)
1208 # first we figure out how many cds we're dealing with by 1243 # first we figure out how many cds we're dealing with by
1209 # the # of files they gave us 1244 # the # of files they gave us
1210 local cdcnt=0 1245 local cdcnt=0
1211 local f= 1246 local f=
1212 for f in "$@" ; do 1247 for f in "$@" ; do
1213 cdcnt=$((cdcnt + 1)) 1248 ((++cdcnt))
1214 export CDROM_CHECK_${cdcnt}="$f" 1249 export CDROM_CHECK_${cdcnt}="$f"
1215 done 1250 done
1216 export CDROM_TOTAL_CDS=${cdcnt} 1251 export CDROM_TOTAL_CDS=${cdcnt}
1217 export CDROM_CURRENT_CD=1 1252 export CDROM_CURRENT_CD=1
1218 1253
1219 # now we see if the user gave use CD_ROOT ... 1254 # now we see if the user gave use CD_ROOT ...
1220 # if they did, let's just believe them that it's correct 1255 # if they did, let's just believe them that it's correct
1221 if [[ ! -z ${CD_ROOT} ]] ; then
1222 export CDROM_ROOT=${CD_ROOT}
1223 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1224 return
1225 fi
1226 # do the same for CD_ROOT_X
1227 if [[ ! -z ${CD_ROOT_1} ]] ; then 1256 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1228 local var= 1257 local var=
1229 cdcnt=0 1258 cdcnt=0
1230 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1259 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1231 cdcnt=$((cdcnt + 1)) 1260 ((++cdcnt))
1232 var="CD_ROOT_${cdcnt}" 1261 var="CD_ROOT_${cdcnt}"
1262 [[ -z ${!var} ]] && var="CD_ROOT"
1233 if [[ -z ${!var} ]] ; then 1263 if [[ -z ${!var} ]] ; then
1234 eerror "You must either use just the CD_ROOT" 1264 eerror "You must either use just the CD_ROOT"
1235 eerror "or specify ALL the CD_ROOT_X variables." 1265 eerror "or specify ALL the CD_ROOT_X variables."
1236 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1266 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1237 die "could not locate CD_ROOT_${cdcnt}" 1267 die "could not locate CD_ROOT_${cdcnt}"
1238 fi 1268 fi
1239 export CDROM_ROOTS_${cdcnt}="${!var}"
1240 done 1269 done
1241 export CDROM_ROOT=${CDROM_ROOTS_1} 1270 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1242 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1271 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1272 export CDROM_SET=-1
1273 for f in ${CDROM_CHECK_1//:/ } ; do
1274 ((++CDROM_SET))
1275 [[ -e ${CD_ROOT}/${f} ]] && break
1276 done
1277 export CDROM_MATCH=${f}
1243 return 1278 return
1244 fi 1279 fi
1245 1280
1281 # User didn't help us out so lets make sure they know they can
1282 # simplify the whole process ...
1246 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1283 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1247 einfon "This ebuild will need the " 1284 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1248 if [[ -z ${CDROM_NAME} ]] ; then
1249 echo "cdrom for ${PN}."
1250 else
1251 echo "${CDROM_NAME}."
1252 fi
1253 echo 1285 echo
1254 einfo "If you do not have the CD, but have the data files" 1286 einfo "If you do not have the CD, but have the data files"
1255 einfo "mounted somewhere on your filesystem, just export" 1287 einfo "mounted somewhere on your filesystem, just export"
1256 einfo "the variable CD_ROOT so that it points to the" 1288 einfo "the variable CD_ROOT so that it points to the"
1257 einfo "directory containing the files." 1289 einfo "directory containing the files."
1261 echo 1293 echo
1262 else 1294 else
1263 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1295 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1264 cdcnt=0 1296 cdcnt=0
1265 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1297 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1266 cdcnt=$((cdcnt + 1)) 1298 ((++cdcnt))
1267 var="CDROM_NAME_${cdcnt}" 1299 var="CDROM_NAME_${cdcnt}"
1268 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1300 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1269 done 1301 done
1270 echo 1302 echo
1271 einfo "If you do not have the CDs, but have the data files" 1303 einfo "If you do not have the CDs, but have the data files"
1272 einfo "mounted somewhere on your filesystem, just export" 1304 einfo "mounted somewhere on your filesystem, just export"
1273 einfo "the following variables so they point to the right place:" 1305 einfo "the following variables so they point to the right place:"
1274 einfon "" 1306 einfon ""
1275 cdcnt=0 1307 cdcnt=0
1276 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1308 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1277 cdcnt=$((cdcnt + 1)) 1309 ((++cdcnt))
1278 echo -n " CD_ROOT_${cdcnt}" 1310 echo -n " CD_ROOT_${cdcnt}"
1279 done 1311 done
1280 echo 1312 echo
1281 einfo "Or, if you have all the files in the same place, or" 1313 einfo "Or, if you have all the files in the same place, or"
1282 einfo "you only have one cdrom, you can export CD_ROOT" 1314 einfo "you only have one cdrom, you can export CD_ROOT"
1285 echo 1317 echo
1286 einfo "For example:" 1318 einfo "For example:"
1287 einfo "export CD_ROOT_1=/mnt/cdrom" 1319 einfo "export CD_ROOT_1=/mnt/cdrom"
1288 echo 1320 echo
1289 fi 1321 fi
1322
1323 export CDROM_SET=""
1290 export CDROM_CURRENT_CD=0 1324 export CDROM_CURRENT_CD=0
1291 cdrom_load_next_cd 1325 cdrom_load_next_cd
1292} 1326}
1293 1327
1294# this is only used when you need access to more than one cd. 1328# this is only used when you need access to more than one cd.
1295# when you have finished using the first cd, just call this function. 1329# when you have finished using the first cd, just call this function.
1296# when it returns, CDROM_ROOT will be pointing to the second cd. 1330# when it returns, CDROM_ROOT will be pointing to the second cd.
1297# remember, you can only go forward in the cd chain, you can't go back. 1331# remember, you can only go forward in the cd chain, you can't go back.
1298cdrom_load_next_cd() { 1332cdrom_load_next_cd() {
1299 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1300 local var= 1333 local var
1301 1334 ((++CDROM_CURRENT_CD))
1302 if [[ ! -z ${CD_ROOT} ]] ; then
1303 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1304 return
1305 fi
1306 1335
1307 unset CDROM_ROOT 1336 unset CDROM_ROOT
1308 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1337 var=CD_ROOT_${CDROM_CURRENT_CD}
1338 [[ -z ${!var} ]] && var="CD_ROOT"
1309 if [[ -z ${!var} ]] ; then 1339 if [[ -z ${!var} ]] ; then
1310 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1340 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1311 cdrom_locate_file_on_cd ${!var} 1341 _cdrom_locate_file_on_cd ${!var}
1312 else 1342 else
1313 export CDROM_ROOT=${!var} 1343 export CDROM_ROOT=${!var}
1314 fi 1344 fi
1315 1345
1316 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1346 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1321# all it does is try to locate a give file on a cd ... if the cd isn't 1351# all it does is try to locate a give file on a cd ... if the cd isn't
1322# found, then a message asking for the user to insert the cdrom will be 1352# found, then a message asking for the user to insert the cdrom will be
1323# displayed and we'll hang out here until: 1353# displayed and we'll hang out here until:
1324# (1) the file is found on a mounted cdrom 1354# (1) the file is found on a mounted cdrom
1325# (2) the user hits CTRL+C 1355# (2) the user hits CTRL+C
1326cdrom_locate_file_on_cd() { 1356_cdrom_locate_file_on_cd() {
1357 local mline=""
1358 local showedmsg=0
1359
1327 while [[ -z ${CDROM_ROOT} ]] ; do 1360 while [[ -z ${CDROM_ROOT} ]] ; do
1328 local dir=$(dirname "$*") 1361 local i=0
1362 local -a cdset=(${*//:/ })
1363 if [[ -n ${CDROM_SET} ]] ; then
1364 cdset=(${cdset[${CDROM_SET}]})
1365 fi
1366
1367 while [[ -n ${cdset[${i}]} ]] ; do
1368 local dir=$(dirname ${cdset[${i}]})
1329 local file=$(basename "$*") 1369 local file=$(basename ${cdset[${i}]})
1330 local mline=""
1331 local showedmsg=0
1332 1370
1333 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1371 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1334 [[ -d ${mline}/${dir} ]] || continue 1372 [[ -d ${mline}/${dir} ]] || continue
1335 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \ 1373 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1336 && export CDROM_ROOT=${mline} 1374 export CDROM_ROOT=${mline}
1375 export CDROM_SET=${i}
1376 export CDROM_MATCH=${cdset[${i}]}
1377 return
1378 fi
1379 done
1380
1381 ((++i))
1337 done 1382 done
1338 1383
1339 if [[ -z ${CDROM_ROOT} ]] ; then
1340 echo 1384 echo
1341 if [[ ${showedmsg} -eq 0 ]] ; then 1385 if [[ ${showedmsg} -eq 0 ]] ; then
1342 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1386 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1343 if [[ -z ${CDROM_NAME} ]] ; then 1387 if [[ -z ${CDROM_NAME} ]] ; then
1344 einfo "Please insert the cdrom for ${PN} now !" 1388 einfo "Please insert+mount the cdrom for ${PN} now !"
1345 else
1346 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1347 fi
1348 else 1389 else
1349 if [[ -z ${CDROM_NAME_1} ]] ; then
1350 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1351 else
1352 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1353 einfo "Please insert+mount the ${!var} cdrom now !" 1390 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1354 fi
1355 fi 1391 fi
1356 showedmsg=1 1392 else
1393 if [[ -z ${CDROM_NAME_1} ]] ; then
1394 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1395 else
1396 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1397 einfo "Please insert+mount the ${!var} cdrom now !"
1398 fi
1357 fi 1399 fi
1400 showedmsg=1
1401 fi
1358 einfo "Press return to scan for the cd again" 1402 einfo "Press return to scan for the cd again"
1359 einfo "or hit CTRL+C to abort the emerge." 1403 einfo "or hit CTRL+C to abort the emerge."
1360 echo 1404 echo
1361 einfo "If you are having trouble with the detection" 1405 einfo "If you are having trouble with the detection"
1362 einfo "of your CD, it is possible that you do not have" 1406 einfo "of your CD, it is possible that you do not have"
1363 einfo "Joliet support enabled in your kernel. Please" 1407 einfo "Joliet support enabled in your kernel. Please"
1364 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1408 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1365 read 1409 read || die "something is screwed with your system"
1366 fi
1367 done 1410 done
1368} 1411}
1369 1412
1370# Make sure that LINGUAS only contains languages that 1413# Make sure that LINGUAS only contains languages that
1371# a package can support 1414# a package can support
1381# directories and uses the union of the lists. 1424# directories and uses the union of the lists.
1382strip-linguas() { 1425strip-linguas() {
1383 local ls newls 1426 local ls newls
1384 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1427 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1385 local op=$1; shift 1428 local op=$1; shift
1386 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1429 ls=" $(find "$1" -name '*.po' -exec basename {} \;) "; shift
1387 local d f 1430 local d f
1388 for d in "$@" ; do 1431 for d in "$@" ; do
1389 if [[ ${op} == "-u" ]] ; then 1432 if [[ ${op} == "-u" ]] ; then
1390 newls=${ls} 1433 newls=${ls}
1391 else 1434 else
1392 newls="" 1435 newls=""
1393 fi 1436 fi
1394 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1437 for f in $(find "$d" -name '*.po' -exec basename {} \;) ; do
1395 if [[ ${op} == "-i" ]] ; then 1438 if [[ ${op} == "-i" ]] ; then
1396 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1439 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}"
1397 else 1440 else
1398 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1441 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}"
1399 fi 1442 fi
1455 1498
1456# Jeremy Huddleston <eradicator@gentoo.org>: 1499# Jeremy Huddleston <eradicator@gentoo.org>:
1457# preserve_old_lib /path/to/libblah.so.0 1500# preserve_old_lib /path/to/libblah.so.0
1458# preserve_old_lib_notify /path/to/libblah.so.0 1501# preserve_old_lib_notify /path/to/libblah.so.0
1459# 1502#
1460# These functions are useful when a lib in your package changes --soname. Such 1503# These functions are useful when a lib in your package changes --library. Such
1461# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1504# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1462# would break packages that link against it. Most people get around this 1505# would break packages that link against it. Most people get around this
1463# by using the portage SLOT mechanism, but that is not always a relevant 1506# by using the portage SLOT mechanism, but that is not always a relevant
1464# solution, so instead you can add the following to your ebuilds: 1507# solution, so instead you can add the following to your ebuilds:
1465# 1508#
1496 1539
1497 ewarn "An old version of an installed library was detected on your system." 1540 ewarn "An old version of an installed library was detected on your system."
1498 ewarn "In order to avoid breaking packages that link against it, this older version" 1541 ewarn "In order to avoid breaking packages that link against it, this older version"
1499 ewarn "is not being removed. In order to make full use of this newer version," 1542 ewarn "is not being removed. In order to make full use of this newer version,"
1500 ewarn "you will need to execute the following command:" 1543 ewarn "you will need to execute the following command:"
1501 ewarn " revdep-rebuild --soname ${SONAME}" 1544 ewarn " revdep-rebuild --library ${SONAME}"
1502 ewarn 1545 ewarn
1503 ewarn "After doing that, you can safely remove ${LIB}" 1546 ewarn "After doing that, you can safely remove ${LIB}"
1504 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1547 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1505 fi 1548 fi
1506} 1549}
1519 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1562 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1520 1563
1521 local PKG=$(best_version $1) 1564 local PKG=$(best_version $1)
1522 shift 1565 shift
1523 1566
1524 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1567 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1568
1569 # if the USE file doesnt exist, assume the $PKG is either
1570 # injected or package.provided
1525 [[ ! -e ${USEFILE} ]] && return 1 1571 [[ ! -e ${USEFILE} ]] && return 0
1526 1572
1527 local USE_BUILT=$(<${USEFILE}) 1573 local USE_BUILT=$(<${USEFILE})
1528 while [[ $# -gt 0 ]] ; do 1574 while [[ $# -gt 0 ]] ; do
1529 if [[ ${opt} = "-o" ]] ; then 1575 if [[ ${opt} = "-o" ]] ; then
1530 has $1 ${USE_BUILT} && return 0 1576 has $1 ${USE_BUILT} && return 0
1582# $4 == extra LD_LIBRARY_PATH's (make it : delimited) 1628# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1583# $5 == path for wrapper 1629# $5 == path for wrapper
1584make_wrapper() { 1630make_wrapper() {
1585 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1631 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1586 local tmpwrapper=$(emktemp) 1632 local tmpwrapper=$(emktemp)
1633 # We don't want to quote ${bin} so that people can pass complex
1634 # things as $bin ... "./someprog --args"
1587 cat << EOF > "${tmpwrapper}" 1635 cat << EOF > "${tmpwrapper}"
1588#!/bin/sh 1636#!/bin/sh
1589cd "${chdir}" 1637cd "${chdir:-.}"
1638if [ -n "${libdir}" ] ; then
1639 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1590export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1640 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1641 else
1642 export LD_LIBRARY_PATH="${libdir}"
1643 fi
1644fi
1591exec ${bin} "\$@" 1645exec ${bin} "\$@"
1592EOF 1646EOF
1593 chmod go+rx "${tmpwrapper}" 1647 chmod go+rx "${tmpwrapper}"
1594 if [ -n "${5}" ] 1648 if [[ -n ${path} ]] ; then
1595 then
1596 exeinto ${5} 1649 exeinto "${path}"
1597 newexe "${tmpwrapper}" "${wrapper}" 1650 newexe "${tmpwrapper}" "${wrapper}"
1598 else 1651 else
1599 newbin "${tmpwrapper}" "${wrapper}" 1652 newbin "${tmpwrapper}" "${wrapper}"
1600 fi 1653 fi
1601} 1654}

Legend:
Removed from v.1.200  
changed lines
  Added in v.1.230

  ViewVC Help
Powered by ViewVC 1.1.20